TLMPWEB_VERSION=1
TLMPWEB_RELEASE=22
LDEVEL=/usr/lib/linuxconf-devel/
USR_BIN=$(RPM_BUILD_ROOT)/usr/bin
CGI=/var/www/cgi-bin
CGI_BIN=$(RPM_BUILD_ROOT)$(CGI)
USR_INCLUDE=$(RPM_BUILD_ROOT)/usr/include/tlmp

TLMP_LIB=$(RPM_BUILD_ROOT)/usr/lib/tlmp
FLAGS=-funsigned-char -g -O2 -Wall 
GPPLINK=g++
GPP=g++

MYCFLAGS= -DPUBLIC= -DPRIVATE= -DPROTECTED= -DTLMPWEB_VERSION=\"$(TLMPWEB_VERSION)\"

CPP_DEFINES=-Dexport= -DSTATIC= -DEXPORT= -DPUBLIC= -DPROTECTED= -DPRIVATE= -DVIRTUAL= \
	-Dnear= -Dfar=  -D_GNU_SOURCE -DUNIX -DTOOLS_VERSION=$(TOOLS_VERSION) \
	-DTLMPWEB_RELEASE=$(TLMPWEB_RELEASE)

.cc.o:
	@echo "    " $<
	@$(GPP) $(MYCFLAGS) $(FLAGS) $(CPP_DEFINES) \
		-I../tlmpweb \
		-I/usr/include/tlmp \
		-I/usr/include/linuxconf -c $< -o $@

.cc.os:
	@echo "    " $<
	@$(GPP) -fPIC $(MYCFLAGS) $(FLAGS) $(CPP_DEFINES) \
		-I../tlmpweb \
		-I/usr/include/tlmp \
		-I/usr/include/linuxconf -c $< -o $@


.SUFFIXES: .tlcc .cc .os

.tlcc.o:
	@echo "    " $<
	@tlcc $< tmp.cpp
	@$(GPP) $(FLAGS) $(CPP_DEFINES) -DPACKAGE_REV=\"$(PACKAGE_REV)\" \
		-I/usr/include/tlmp -I/usr/include/linuxconf \
		-c tmp.cpp -o $@
	rm -f tmp.cpp

.tlcc.os:
	@echo "    " $<
	@tlcc $< tmp.cpp
	@$(GPP) -fPIC $(FLAGS) $(CPP_DEFINES) -DPACKAGE_REV=\"$(PACKAGE_REV)\" \
		-I/usr/include/tlmp -I/usr/include/linuxconf \
		-c tmp.cpp -o $@
	rm -f tmp.cpp

lib: $(CURDIR).a

$(CURDIR).a: $(OBJS)
	ar cr $(CURDIR).a $(OBJS)
	ranlib $(CURDIR).a

$(CURDIR).so: $(OBJSH)
	$(GPPLINK) -g -shared -Wl,-soname,$(CURDIR).so.1 -o \
		$(CURDIR).so \
		$(OBJSH) $(EXTRAMODLIBS)


msg:
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc *.tlcc

msg.clean:
	$(LDEVEL)/msgclean $(CURDIR).dic
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc *.tlcc

msg.eng:
	mkdir -p $(TLMP_LIB)/help.eng
	$(LDEVEL)/msgcomp -p./ \
		-p../tlmpweb/ \
		$(TLMP_LIB)/help.eng/tlmpweb.eng eE \
		tlmpweb

msg.fr:
	mkdir -p $(TLMP_LIB)/help.fr
	$(LDEVEL)/msgcomp -p./ \
		-p../tlmpweb/ \
		-p../tledit/ \
		$(TLMP_LIB)/help.fr/tlmpweb.fr TFeE \
		tlmpweb

ifdef DIRS
clean: $(LOCAL_CLEAN)
	rm -f x *.o *.obt *.bak .bak *~ *.a *.old *.log *.nap *.nar core *.os
	@for i in $(DIRS); do make -C $$i clean  || exit 1; done
else
clean: $(LOCAL_CLEAN)
	rm -f x *.o *.obt *.bak *~ *.a *.old *.log *.nap *.nar *.os
endif

all:
ifdef DIRS
	@for i in $(DIRS); do make GCC=$(GCC) GPP=$(GPP) -C $$i $@ || exit 1; done
endif


ifdef DIRS
install: $(LOCAL_INSTALL) install_subdirs $(LOCAL_POSTINSTALL)

install_subdirs:
	@echo doing subdirs
	@for i in $(DIRS); do make -C $$i install  || exit 1 ; done
	@echo end subdirs

else
install: $(LOCAL_INSTALL) $(LOCAL_POSTINSTALL)
endif

INDEXPREFIX=$(HOME)/.index/tlmp-$(CURDIR)
index:
	mkdir -p $(HOME)/.index
	tlproto -ceo+i -f$(INDEXPREFIX).nar -n`pwd` `find . -maxdepth 1 -name \*.cc -o -name \*.tlcc`
	tlproto -ceo+d -f/tmp/tmp.nap `find . -maxdepth 1 -name \*.cc -o -name \*.tlcc`
	naperm /tmp/tmp.nap $(INDEXPREFIX).nai $(INDEXPREFIX).nas

pubspec_xml:
	@mkdir -p /tmp/xml
	nacom -x *cc >/tmp/xml/$(CURDIR).xml

