Summary: tlmp web system and utilities
Name: tlmpweb
Version: TLMP_VERSION
Release: TLMP_RPMREV
Vendor: Solucorp
Copyright: GPL
Group: Development/web
Source: ftp://ftp.solucorp.qc.ca/pub/tlmp/src/tlmpweb-TLMP_VERSION.src.tar.gz
BuildRoot: /tmp/tlmp-root
Packager: Jacques Gelinas <jack@solucorp.qc.ca>

%description
This is a set of tools used to build dynamic HTML page using the TLMP
C++ extension. This allows code reuse and simplify the setup of
large site.

%package sql
requires: tlmpsql >= 1.5
Summary: TLMP-web database oriented components
Group: Development/web
%description sql
Provides some SQL components (requires tlmpsql) including websession_sql
which is useful to have persistent data accross several user request.

%prep
%setup

%build
make CFLAGS="$RPM_OPT_FLAGS"

%install
if [ "$RPM_BUILD_ROOT" != "" -a "$RPM_BUILD_ROOT" != "/" ] ; then
	rm -rf $RPM_BUILD_ROOT
fi
export RPM_BUILD_ROOT
make install

%clean
if [ "$RPM_BUILD_ROOT" != "" -a "$RPM_BUILD_ROOT" != "/" ] ; then
	rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
/var/www/cgi-bin/tlmpweb
/usr/lib/tlmp/help.eng/tlmpweb.eng
/usr/lib/tlmp/help.fr/tlmpweb.fr
/usr/bin/tlmpwebcc
/usr/bin/tlmpweb.test.sh
/usr/include/tlmp/tlmpweb.*
/usr/include/tlmp/tlmpdoc.*
/usr/lib/tlmp/lib/tlmpdoc.so

%files sql
%defattr(-,root,root)
/usr/lib/tlmp/lib/tlmpwebsql.so
/usr/lib/tlmp/websession.sh
/usr/include/tlmp/tlmpwebsql.*

%post
SRM=/etc/httpd/conf/srm.conf
SRMTMP=/var/tmp/srm.conf.tmp
grep -v "application/x-httpd-hc" $SRM >$SRMTMP
echo AddType application/x-httpd-hc .hc >> $SRMTMP
echo Action application/x-httpd-hc /cgi-bin/tlmpweb >> $SRMTMP

echo Checking index.hc support
if grep DirectoryIndex $SRMTMP | grep -q index.hc >/dev/null
then
	echo Already available
else
	echo Adding ability to create index.hc as default document of a directory
	echo
	sed "s/DirectoryIndex/DirectoryIndex index.hc/" <$SRMTMP >$SRMTMP.2
	mv $SRMTMP.2 $SRMTMP
fi


cp $SRM $SRM.orig
cp $SRMTMP $SRM
echo $SRM has been updated to support .hc extension
echo The original has been left in $SRM.orig
echo
echo You must restart the apache server for this to be effective
echo Just do
if [ -f /etc/rc.d/init.d/httpd.init ] ; then
	echo /etc/rc.d/init.d/httpd.init stop
	echo /etc/rc.d/init.d/httpd.init start
else
	echo /etc/rc.d/init.d/httpd stop
	echo /etc/rc.d/init.d/httpd start
fi

