#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "tlmpweb.h"

void url_puts (const char *s)
{
	while (*s != '\0'){
		char carac = *s++;
		if (carac == ' '){
			fputc ('+',stdout);
		}else if (carac == '+'){
			fputs ("%2B",stdout);
		}else{
			fputc (carac,stdout);
		}
	}
}

const char *url_encode (SSTRINGS &tb, const char *s)
{
	char tmp[strlen(s)*3+1];
	char *dst = tmp;
	while (*s != '\0'){
		char carac = *s++;
		if (carac == ' '){
			*dst++ = '+';
		}else if (carac == '+'){
			*dst++ = '%';
			*dst++ = '2';
			*dst++ = 'B';
		}else{
			*dst++ = carac;
		}
	}
	*dst = '\0';
	SSTRING *ss = new SSTRING(tmp);
	tb.add (ss);
	return ss->get();
}
const char *url_encode (SSTRINGS &tb, const SSTRING &s)
{
	return url_encode (tb,s.get());
}

PUBLIC URL_ENCODE::URL_ENCODE()
{
}

PUBLIC const char *URL_ENCODE::enc(const char *s)
{
	return url_encode (tb,s);
}
PUBLIC const char *URL_ENCODE::enc(const SSTRING &s)
{
	return url_encode (tb,s);
}

static char *target = NULL;

void url_setframe_target(const char *s)
{
	free (target);
	target = NULL;
	if (s != NULL) target = strdup(s);
}

static void url_addtarget()
{
	if (target != NULL) printf (" target=%s",target);
}

void url_http (const char *path, const char *title)
{
	fputs ("<a href=",stdout);
	url_puts(path);
	url_addtarget();
	printf (">%s</a>\n",title);
}

void url_http (const char *server, const char *path, const char *title)
{
	printf ("<a href=http://%s",server);
	url_puts(path);
	url_addtarget();
	printf (">%s</a>\n",title);
}

/*
	Present an ftp url with some text
*/
void url_ftp (const char *server, const char *path, const char *title)
{
	printf ("<a href=ftp://%s%s>%s</a>\n",server,path,title);
}

/*
	Present an ftp url using the url itself as the text
*/
void url_ftp (const char *server, const char *path)
{
	printf ("<a href=ftp://%s%s>",server,path);
	printf ("ftp://%s%s",server,path);
	printf ("</a>\n");
}

