#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include "tlmpweb.h"


/*
	Copy a random sequence into random[]
*/
void websession_setrandom (char random[20])
{
	int fd = open ("/dev/random",O_RDONLY);
	random[0] = '\0';
	if (fd != -1){
		char buf[9];
		if (read(fd,buf,9)==9){
			for (int i=0; i<9; i++){
				sprintf (random+i*2,"%02x",buf[i]);
			}
		}
		close (fd);
	}
}

/*
	Record the value of a cookie
*/
void websession_setcookie (const char *name, const char *value, time_t expire)
{
	#if 0
		struct tm *t = gmtime (&expire);
		// Thursday, 01-Jan-70 00:00:10 GMT
		char timestr[200];
		strftime (timestr,sizeof(timestr)-1,"%A, %d-%b-%Y %H:%M:%S GMT",t);
		tlmpweb_header ("Set-Cookie","%s=%s; expires=%s",name,value,timestr);
	#else
		tlmpweb_header ("Set-Cookie","%s=%s",name,value);
	#endif
}

bool _F_websession::auth (WEBSESSION_INFO &info, const char *passwd)
{
	return true;
}

int _F_websession::load(WEBSESSION_INFO &info, W_VAR *[], int )
{
	return 0;
}
int _F_websession::save(WEBSESSION_INFO &info, W_VAR *[], int)
{
	return 0;
}

void _F_websession::setrealm(const char *realm)
{
	printf ("realm=%s\r\n",realm);
}

static W_SSTRING user ("user");

void websession(_F_websession &c, const char *realm)
{
	WEBSESSION_INFO info;
	info.realm = realm;
	info.key = -1;
	info.random[0] = '\0';
	info.user = "";
	{
		const char *cookie = tlmpweb_getcookie("websession");
		if (cookie != NULL){
			// We make sure this cookie looks like the one we generate
			int key = atoi(cookie);
			const char *pt = strchr(cookie,'-');
			if (pt != NULL && strlen(pt)==19){
				pt++;
				const char *start = pt;
				while (*pt != '\0'){
					if (!isxdigit(*pt)) break;
					pt++;
				}
				if (*pt == '\0'){
					info.key = key;
					strcpy (info.random,start);
				}
			}
		}
	}
	if (!c.auth(info,"")){
		tlmpweb_header ("Status","401 Authorization Required");
		tlmpweb_header ("WWW-Authenticate","Basic realm=\"%s\"",realm);
		tlmpweb_doctype ("text/html");
		printf ("Please authenticate\n");
		fflush (stdout);
	}else if (c.init(info) != -1){
		W_VAR *first = wvar_getfirst();
		// First we count the session variable
		int nbvar=0;
		while (first != NULL){
			const char *f = first->getflags();
			if (strchr(f,'S')!=NULL) nbvar++;
			first = first->getnext();
		}
		W_VAR *tbvar[nbvar];
		first = wvar_getfirst();
		int no=0;
		while (first != NULL){
			const char *f = first->getflags();
			if (strchr(f,'S')!=NULL) tbvar[no++] = first;
			first = first->getnext();
		}
		if (c.load(info,tbvar,nbvar) != -1){
			c.exec(info);
			c.save(info,tbvar,nbvar);
		}
	}
}



